// ttfdasm	ver.0.00

#include	<Be.h>

void	quit(char *s);
int		readtbl(FILE *fp,uchar *bf,uint32 tb);
int		disasm(uchar *bf,int bl);

uchar	*buf=NULL;

int main(int argc,char **argv)
{
	if(argc!=2)quit("\n\tusage: ttfdasm ttf_file");
	FILE	*fp=fopen(argv[1],"rb");
	if(fp==NULL)quit("cannot open");
	buf=new uchar[0x1000000];
	int		len;
//fpgm
	len=readtbl(fp,buf,'fpgm');
	if(len==0){fclose(fp);quit("not found tbl[fpgm]");}
printf("[ fpgm ]\n");
	disasm(buf,len);
//prep
	len=readtbl(fp,buf,'prep');
	if(len==0){fclose(fp);quit("not found tbl[prep]");}
printf("[ prep ]\n");
	disasm(buf,len);
//glyf
	len=readtbl(fp,buf,'head');
	if(len==0){fclose(fp);quit("not found tbl[head]");}
	bool	is32loca=(B_BENDIAN_TO_HOST_INT16(*(uint16*)(buf+50))==1);
	len=readtbl(fp,buf,'maxp');
	if(len==0){fclose(fp);quit("not found tbl[maxp]");}
	uint16	glfs=B_BENDIAN_TO_HOST_INT16(*(uint16*)(buf+4));
	len=readtbl(fp,buf,'loca');
	if(len==0){fclose(fp);quit("not found tbl[loca]");}
	uchar	*gbuf=buf+len;
	len=readtbl(fp,gbuf,'glyf');
	if(len==0){fclose(fp);quit("not found tbl[glyf]");}
printf("[ glyf ]\n");
	for(int i=0;i<glfs;i++){
		uchar	*g,*ng;
		if(is32loca){
			g=gbuf+B_BENDIAN_TO_HOST_INT32(*((uint32*)buf+i));
			ng=(buf+i*4<gbuf)?(gbuf+B_BENDIAN_TO_HOST_INT32(*((uint32*)buf+i+1))):(gbuf+len);
		}else{
			g=gbuf+B_BENDIAN_TO_HOST_INT16(*((uint16*)buf+i))*2;
			ng=(buf+i*2<gbuf)?(gbuf+B_BENDIAN_TO_HOST_INT16(*((uint16*)buf+i))*2):(gbuf+len);
		}
printf("gno=%04x : goff=%08x : glen=%04x : ",i,g-gbuf,ng-g);
		if(g==ng){printf("space\n");continue;}
		int16	noc=B_BENDIAN_TO_HOST_INT16(*(uint16*)g);
		g+=10;
		if(noc>=0){	//simple glyph
			g+=noc*2;
			uint16	ilen=B_BENDIAN_TO_HOST_INT16(*(uint16*)g);
			g+=2;
printf("simpl ilen=%04x\n",ilen);
			disasm(g,ilen);
		}else{		//composite
			for(int ip=0;;ip++){
				uint16	flg=B_BENDIAN_TO_HOST_INT16(*(uint16*)g);
				g+=4;
				if(flg&0x0001)g+=4;else g+=2;
				if(flg&0x0008)g+=2;else if(flg&0x0040)g+=4;else if(flg&0x0080)g+=8;
				if(!(flg&0x0020)){
					if(flg&0x0100){
						uint16	ilen=B_BENDIAN_TO_HOST_INT16(*(uint16*)g);
						g+=2;
printf("compo ilen=%04x\n",ilen);
						disasm(g,ilen);
					}
					break;
				}
			}
		}
	}

	fclose(fp);
	quit("");
}

void quit(char *s)
{
	if(buf)delete buf;
	if(*s)printf("error: %s\n",s);
	else printf("complete\n");
	exit(0);
}

int readtbl(FILE *fp,uchar *bf,uint32 tb)
{
	int	len=0;
	fseek(fp,0,0);	fread(bf,12,1,fp);
	if(B_BENDIAN_TO_HOST_INT32(*(uint32*)bf)!=0x10000)return(len);	//sfntVersion
	int		tbls=B_BENDIAN_TO_HOST_INT16(*(uint16*)(bf+4));
	fread(bf,tbls,16,fp);

	for(int i=0;i<tbls;i++){
		uint32	*p=(uint32*)(bf+i*16);
		uint32	tname=B_BENDIAN_TO_HOST_INT32(*(p+0));
		if(tname!=tb)continue;
		uint32	off=B_BENDIAN_TO_HOST_INT32(*(p+2));
		len=B_BENDIAN_TO_HOST_INT32(*(p+3));
//printf("read [%c%c%c%c] off=%08x len=%08x\n",tname>>24,tname>>16,tname>>8,tname,off,len);
		fseek(fp,off,0);	fread(bf,len,1,fp);
		break;
	}
	return(len);
}

int disasm(uchar *bf,int bl)
{
	for(int i=0;i<bl;i++){
		if(bf[i]==0x40){
			int	c=bf[i+1];
			printf("%04x : %02x %02x\tNPUSHB[%02x]\n",i,bf[i],bf[i+1],c);
			printf("     :");for(int j=0;j<c;j++)printf(" %02x",bf[i+2+j]);printf("\n");
			i+=c+1;
		}else if(bf[i]==0x41){
			int	c=bf[i+1];
			printf("%04x : %02x %02x\tNPUSHW[%02x]\n",i,bf[i],bf[i+1],c);
			printf("     :");for(int j=0;j<c;j++)printf(" %02x%02x",bf[i+2+j*2],bf[i+2+j*2+1]);printf("\n");
			i+=c*2+1;
		}else if((bf[i]>=0xb0)&&(bf[i]<=0xb7)){
			int	c=(bf[i]&0x07)+1;
			printf("%04x : %02x\tPUSHB[%02x]\n",i,bf[i],c);
			printf("     :");for(int j=0;j<c;j++)printf(" %02x",bf[i+1+j]);printf("\n");
			i+=c;
		}else if((bf[i]>=0xb8)&&(bf[i]<=0xbf)){
			int	c=(bf[i]&0x07)+1;
			printf("%04x : %02x\tPUSHW[%02x]\n",i,bf[i],c);
			printf("     :");for(int j=0;j<c;j++)printf(" %02x%02x",bf[i+1+j*2],bf[i+1+j*2+1]);printf("\n");
			i+=c*2;
		}else if(bf[i]==0x43){
			printf("%04x : %02x\tRS\n",i,bf[i]);
		}else if(bf[i]==0x42){
			printf("%04x : %02x\tWS\n",i,bf[i]);
		}else if(bf[i]==0x44){
			printf("%04x : %02x\tWCVTP\n",i,bf[i]);
		}else if(bf[i]==0x70){
			printf("%04x : %02x\tWCVTF\n",i,bf[i]);
		}else if(bf[i]==0x45){
			printf("%04x : %02x\tRCVT\n",i,bf[i]);
		}else if((bf[i]>=0x00)&&(bf[i]<=0x01)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSVTCA(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x02)&&(bf[i]<=0x03)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSPVTCA(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x04)&&(bf[i]<=0x05)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSFVTCA(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x06)&&(bf[i]<=0x07)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSPVTL(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x08)&&(bf[i]<=0x09)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSFVTL(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x0e){
			printf("%04x : %02x\tSFVTPV\n",i,bf[i]);
		}else if((bf[i]>=0x86)&&(bf[i]<=0x87)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSDPVTL(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x0a){
			printf("%04x : %02x\tSPVFS\n",i,bf[i]);
		}else if(bf[i]==0x0b){
			printf("%04x : %02x\tSFVFS\n",i,bf[i]);
		}else if(bf[i]==0x0c){
			printf("%04x : %02x\tGPV\n",i,bf[i]);
		}else if(bf[i]==0x0d){
			printf("%04x : %02x\tGFV\n",i,bf[i]);
		}else if(bf[i]==0x10){
			printf("%04x : %02x\tSRP0\n",i,bf[i]);
		}else if(bf[i]==0x11){
			printf("%04x : %02x\tSRP1\n",i,bf[i]);
		}else if(bf[i]==0x12){
			printf("%04x : %02x\tSRP2\n",i,bf[i]);
		}else if(bf[i]==0x13){
			printf("%04x : %02x\tSZP0\n",i,bf[i]);
		}else if(bf[i]==0x14){
			printf("%04x : %02x\tSZP1\n",i,bf[i]);
		}else if(bf[i]==0x15){
			printf("%04x : %02x\tSZP2\n",i,bf[i]);
		}else if(bf[i]==0x16){
			printf("%04x : %02x\tSZPS\n",i,bf[i]);
		}else if(bf[i]==0x19){
			printf("%04x : %02x\tRTHG\n",i,bf[i]);
		}else if(bf[i]==0x18){
			printf("%04x : %02x\tRTG\n",i,bf[i]);
		}else if(bf[i]==0x3d){
			printf("%04x : %02x\tRTDG\n",i,bf[i]);
		}else if(bf[i]==0x7d){
			printf("%04x : %02x\tRDTG\n",i,bf[i]);
		}else if(bf[i]==0x7c){
			printf("%04x : %02x\tRUTG\n",i,bf[i]);
		}else if(bf[i]==0x7a){
			printf("%04x : %02x\tROFF\n",i,bf[i]);
		}else if(bf[i]==0x76){
			printf("%04x : %02x\tSROUND\n",i,bf[i]);
		}else if(bf[i]==0x77){
			printf("%04x : %02x\tS45ROUND\n",i,bf[i]);
		}else if(bf[i]==0x17){
			printf("%04x : %02x\tSLOOP\n",i,bf[i]);
		}else if(bf[i]==0x1a){
			printf("%04x : %02x\tSMD\n",i,bf[i]);
		}else if(bf[i]==0x8e){
			printf("%04x : %02x\tINSTCTRL\n",i,bf[i]);
		}else if(bf[i]==0x85){
			printf("%04x : %02x\tSCANCTRL\n",i,bf[i]);
		}else if(bf[i]==0x8D){
			printf("%04x : %02x\tSCANTYPE\n",i,bf[i]);
		}else if(bf[i]==0x1d){
			printf("%04x : %02x\tSCVTCI\n",i,bf[i]);
		}else if(bf[i]==0x1e){
			printf("%04x : %02x\tSSWCI\n",i,bf[i]);
		}else if(bf[i]==0x1f){
			printf("%04x : %02x\tSSW\n",i,bf[i]);
		}else if(bf[i]==0x4d){
			printf("%04x : %02x\tFLIPON\n",i,bf[i]);
		}else if(bf[i]==0x4e){
			printf("%04x : %02x\tFLIPOFF\n",i,bf[i]);
		}else if(bf[i]==0x7e){
			printf("%04x : %02x\tSANGW\n",i,bf[i]);
		}else if(bf[i]==0x5e){
			printf("%04x : %02x\tSDB\n",i,bf[i]);
		}else if(bf[i]==0x5f){
			printf("%04x : %02x\tSDS\n",i,bf[i]);
		}else if((bf[i]>=0x46)&&(bf[i]<=0x47)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tGC(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x48){
			printf("%04x : %02x\tSCFS\n",i,bf[i]);
		}else if((bf[i]>=0x49)&&(bf[i]<=0x4a)){
			int	c=bf[i]-0x49;
			printf("%04x : %02x\tMD(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x4b){
			printf("%04x : %02x\tMPPEM\n",i,bf[i]);
		}else if(bf[i]==0x4c){
			printf("%04x : %02x\tMPS\n",i,bf[i]);
//page2
		}else if(bf[i]==0x80){
			printf("%04x : %02x\tFLIPPT\n",i,bf[i]);
		}else if(bf[i]==0x81){
			printf("%04x : %02x\tFLIPRGON\n",i,bf[i]);
		}else if(bf[i]==0x82){
			printf("%04x : %02x\tFLIPRGOFF\n",i,bf[i]);
		}else if((bf[i]>=0x32)&&(bf[i]<=0x33)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSHP(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x34)&&(bf[i]<=0x35)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSHC(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x36)&&(bf[i]<=0x37)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tSHZ(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x38){
			printf("%04x : %02x\tSHPIX\n",i,bf[i]);
		}else if((bf[i]>=0x3a)&&(bf[i]<=0x3b)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tMSIRP(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x2e)&&(bf[i]<=0x2f)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tMDAP(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x3e)&&(bf[i]<=0x3f)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tMIAP(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0xc0)&&(bf[i]<=0xdf)){
			int	c=bf[i]&0x1f;
			printf("%04x : %02x\tMDRP(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0xe0)&&(bf[i]<=0xff)){
			int	c=bf[i]&0x1f;
			printf("%04x : %02x\tMIRP(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x3c){
			printf("%04x : %02x\tALIGNRP\n",i,bf[i]);
		}else if(bf[i]==0x0f){
			printf("%04x : %02x\tISECT\n",i,bf[i]);
		}else if(bf[i]==0x27){
			printf("%04x : %02x\tALIGNPTS\n",i,bf[i]);
		}else if(bf[i]==0x39){
			printf("%04x : %02x\tIP\n",i,bf[i]);
		}else if(bf[i]==0x29){
			printf("%04x : %02x\tUTP\n",i,bf[i]);
		}else if((bf[i]>=0x30)&&(bf[i]<=0x31)){
			int	c=bf[i]&0x01;
			printf("%04x : %02x\tIUP(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x5d){
			printf("%04x : %02x\tDELTAP1\n",i,bf[i]);
		}else if(bf[i]==0x71){
			printf("%04x : %02x\tDELTAP2\n",i,bf[i]);
		}else if(bf[i]==0x72){
			printf("%04x : %02x\tDELTAP3\n",i,bf[i]);
		}else if(bf[i]==0x73){
			printf("%04x : %02x\tDELTAC1\n",i,bf[i]);
		}else if(bf[i]==0x74){
			printf("%04x : %02x\tDELTAC2\n",i,bf[i]);
		}else if(bf[i]==0x75){
			printf("%04x : %02x\tDELTAC3\n",i,bf[i]);
		}else if(bf[i]==0x20){
			printf("%04x : %02x\tDUP\n",i,bf[i]);
		}else if(bf[i]==0x21){
			printf("%04x : %02x\tPOP\n",i,bf[i]);
		}else if(bf[i]==0x22){
			printf("%04x : %02x\tCLEAR\n",i,bf[i]);
		}else if(bf[i]==0x23){
			printf("%04x : %02x\tSWAP\n",i,bf[i]);
		}else if(bf[i]==0x24){
			printf("%04x : %02x\tDEPTH\n",i,bf[i]);
		}else if(bf[i]==0x25){
			printf("%04x : %02x\tCINDEX\n",i,bf[i]);
		}else if(bf[i]==0x26){
			printf("%04x : %02x\tMINDEX\n",i,bf[i]);
		}else if(bf[i]==0x8a){
			printf("%04x : %02x\tROLL\n",i,bf[i]);
		}else if(bf[i]==0x58){
			printf("%04x : %02x\tIF\n",i,bf[i]);
		}else if(bf[i]==0x1B){
			printf("%04x : %02x\tELSE\n",i,bf[i]);
		}else if(bf[i]==0x59){
			printf("%04x : %02x\tEIF\n",i,bf[i]);
		}else if(bf[i]==0x78){
			printf("%04x : %02x\tJROT\n",i,bf[i]);
		}else if(bf[i]==0x1c){
			printf("%04x : %02x\tJMPR\n",i,bf[i]);
		}else if(bf[i]==0x79){
			printf("%04x : %02x\tJROF\n",i,bf[i]);
		}else if(bf[i]==0x50){
			printf("%04x : %02x\tLT\n",i,bf[i]);
		}else if(bf[i]==0x51){
			printf("%04x : %02x\tLTEQ\n",i,bf[i]);
		}else if(bf[i]==0x52){
			printf("%04x : %02x\tGT\n",i,bf[i]);
		}else if(bf[i]==0x53){
			printf("%04x : %02x\tGTEQ\n",i,bf[i]);
		}else if(bf[i]==0x54){
			printf("%04x : %02x\tEQ\n",i,bf[i]);
		}else if(bf[i]==0x55){
			printf("%04x : %02x\tNEQ\n",i,bf[i]);
		}else if(bf[i]==0x56){
			printf("%04x : %02x\tODD\n",i,bf[i]);
		}else if(bf[i]==0x57){
			printf("%04x : %02x\tEVEN\n",i,bf[i]);
		}else if(bf[i]==0x5a){
			printf("%04x : %02x\tAND\n",i,bf[i]);
		}else if(bf[i]==0x5b){
			printf("%04x : %02x\tOR\n",i,bf[i]);
		}else if(bf[i]==0x5c){
			printf("%04x : %02x\tNOT\n",i,bf[i]);
		}else if(bf[i]==0x60){
			printf("%04x : %02x\tADD\n",i,bf[i]);
		}else if(bf[i]==0x61){
			printf("%04x : %02x\tSUB\n",i,bf[i]);
		}else if(bf[i]==0x62){
			printf("%04x : %02x\tDIV\n",i,bf[i]);
		}else if(bf[i]==0x63){
			printf("%04x : %02x\tMUL\n",i,bf[i]);
		}else if(bf[i]==0x64){
			printf("%04x : %02x\tABS\n",i,bf[i]);
		}else if(bf[i]==0x65){
			printf("%04x : %02x\tNEG\n",i,bf[i]);
		}else if(bf[i]==0x66){
			printf("%04x : %02x\tFLOOR\n",i,bf[i]);
		}else if(bf[i]==0x67){
			printf("%04x : %02x\tCEILING\n",i,bf[i]);
		}else if(bf[i]==0x8b){
			printf("%04x : %02x\tMAX\n",i,bf[i]);
		}else if(bf[i]==0x8c){
			printf("%04x : %02x\tMIN\n",i,bf[i]);
		}else if((bf[i]>=0x68)&&(bf[i]<=0x6b)){
			int	c=bf[i]&0x03;
			printf("%04x : %02x\tROUND(%x)\n",i,bf[i],c);
		}else if((bf[i]>=0x6c)&&(bf[i]<=0x6f)){
			int	c=bf[i]&0x03;
			printf("%04x : %02x\tNROUND(%x)\n",i,bf[i],c);
		}else if(bf[i]==0x2c){
			printf("%04x : %02x\tFDEF\n",i,bf[i]);
		}else if(bf[i]==0x2d){
			printf("%04x : %02x\tENDF\n",i,bf[i]);
		}else if(bf[i]==0x2b){
			printf("%04x : %02x\tCALL\n",i,bf[i]);
		}else if(bf[i]==0x2a){
			printf("%04x : %02x\tLOOPCALL\n",i,bf[i]);
		}else if(bf[i]==0x89){
			printf("%04x : %02x\tIDEF\n",i,bf[i]);
		}else if(bf[i]==0x4f){
			printf("%04x : %02x\tDEBUG\n",i,bf[i]);
		}else if(bf[i]==0x88){
			printf("%04x : %02x\tGETINFO\n",i,bf[i]);
		}else{
			printf("%04x : %02x\t--unknown--\n",i,bf[i]);
		}
	}
	printf("\n");
	return(0);
}
